format compact;
path_logs='/scratch2/clear/mairal/large_datasets/logs_siam_revision/';
tabn=[581012 500000 2500000 72309 781265 250000];
tabp=[54 500 1155 20958 47152 16092143];
name={'MM','MM-LS','MISO0','MISO1','MISO2'};
tabepochs=[0 1 2 3 4 5 10 15 20 25 50];
colors={'-^g','-dm','-sb','-*k','-xr','-or','-pr','-rp','-gx','-cx'};
tabdatasets={'covtype','alpha','ocr','real-sim','rcv1','webspam'};

clf;
set(gcf,'position',[1000 500 400 250]);

for dataset=1:6
   load(sprintf('%s/expdc_final_%d_0.mat',path_logs,dataset));
   dataset
   optimm=[objmm, objmmls, objmiso0, objmiso, objmiso2];

   clf;
   for kk=1:size(optimm,2);
      plot(tabepochs,optimm(:,kk),colors{kk},'MarkerSize',10,'LineWidth',2); hold on;
      set(gca,'XTick',0:5:50);
      set(gca,'FontSize',12);
      xlabel(sprintf('Effective passes over data / Dataset %s',tabdatasets{dataset}));
      ylabel('Objective Function');
      if dataset==6
         legend(name);
      end
   end
   set(gcf,'PaperPositionMode','Auto');
   print('-depsc2',sprintf('results/%s_dc_epochs.eps',tabdatasets{dataset}));
end

for dataset=1:6
   load(sprintf('%s/expdc_final_%d_0.mat',path_logs,dataset));
   dataset
   optimm=[sparmm, sparmmls, sparmiso0, sparmiso, sparmiso2];

   clf;
   for kk=1:size(optimm,2);
      plot(tabepochs(1:end),optimm(:,kk),colors{kk},'MarkerSize',10,'LineWidth',2); hold on;
      set(gca,'XTick',0:5:50);
      set(gca,'FontSize',12);
      xlabel(sprintf('Effective passes over data / Dataset %s',tabdatasets{dataset}));
      ylabel('Sparsity');
      if dataset==6
         legend(name);
      end
   end
   V=axis;
   V(4)=max(optimm(2,:));
   V(3)=0;
   axis(V);

   set(gcf,'PaperPositionMode','Auto');
   print('-depsc2',sprintf('results/%s_dc_spars.eps',tabdatasets{dataset}));
end


