function [] = main(dataset,run)
rand('seed',run);
format compact;
if isdeployed
   dataset=str2num(dataset);
   run=str2num(run);
end
addpath('../../trunk/build/');

path_logs='/scratch2/clear/mairal/large_datasets/logs_siam_revision/';
mkdir(path_logs);
name=sprintf('%s/expdc_final_%d_%d.mat',path_logs,dataset,run);
path_datasets='/scratch2/clear/mairal/large_datasets/';
tabdatasets={'covtype','alpha','ocr','real-sim','rcv1','webspam'};
num_dataset=dataset;
dataset=tabdatasets{dataset};

if (strcmp(dataset,'covtype') | strcmp(dataset,'alpha') | strcmp(dataset,'ocr'))
   param.normalized=false; 
   load([path_datasets dataset '.full_norm.mat']);
else
   param.normalized=true;   % we have normalized every dataset
   load([path_datasets dataset '.full.mat']);
end
C=unique(y);
neg=find(y==C(1));
y(neg)=-1;
pos=find(y==C(2));
y(pos)=1;
n=size(X,2);
p=size(X,1);
ind=randperm(n);
X=X(:,ind);
y=y(ind);
density=nnz(X)/(n*p);  % MISO1, for sparse datasets, with minibatches
clear ind;

% set grid of lambda
max_lambda=max(abs(X*y))/n;
tabind=[13 12 23 35 3 4];
dataset
if num_dataset <= 4
   tablambda=max_lambda*(2^(1/8)).^(50:-4:-100);  % order from large to small
else
   tablambda=max_lambda*(2^(1/8)).^(-100:-4:-150);  % order from large to small
end
size(tablambda)
lambda=tablambda(tabind(num_dataset));
tabepochs=[0 1 2 3 4 5 10 15 20 25 50];  % in this script, we compare the results obtained when changing the number of passes on the data.


% Initialization
Beta0b=X*y;
XBeta=X' * Beta0b;
Beta0b = Beta0b * sqrt(sum(y.^2)/ sum(XBeta.^2));

%%% set up general parameters 
param.regul='log-dc';    % many other regularization functions are available
param.eps=0.01;
param.loss='square';     % only square and log are available
param.numThreads=1;    % uses all possible cores
param.warm_restart=false;
param.verbose=false;
param.lambda=lambda;

%% MISO1
param.minibatches=min(n,ceil(1/density));  % size of the minibatches, requires to store twice the size of X 
param.strategy=1;
obj=[];
spar=[];
for ii=1:length(tabepochs)
   param.epochs=tabepochs(ii);   % one pass over the data
   fprintf('EXP WITH %d PASS OVER THE DATA\n',tabepochs(ii));
   tic
   [Beta tmp]=mexIncrementalProx(y,X,Beta0b,param);
   toc
   fprintf('Objective functions: \n');
   obj=[obj; tmp(1,:)];
   obj
   fprintf('Sparsity: \n');
   spar=[spar; sum(Beta ~= 0)];
   spar
end
objmiso=obj;
sparmiso=spar;


%%%% MM-LS
obj=zeros(length(tabepochs),1);
spar=[];
Xt=X';
for ii=1:length(tabepochs)
   param.max_iter=tabepochs(ii);   % one pass over the data
   fprintf('EXP WITH %d PASS OVER THE DATA\n',tabepochs(ii));
   paramfista.regul=param.regul;
   paramfista.loss=param.loss;
   paramfista.L0=1;
   paramfista.max_it=tabepochs(ii);
   paramfista.tol=1e-10;
   paramfista.a=param.eps;
   paramfista.ista=true;
   paramfista.it0=10000;
   paramfista.lambda=n*lambda;
   tic
   [Beta tmp]=mexFistaFlat(y,Xt,Beta0b,paramfista);
   obj(ii)=tmp(1)/n;
   fprintf('Objective functions: \n');
   obj
   fprintf('Sparsity: \n');
   spar=[spar; sum(Beta ~= 0)];
   spar
   toc
end
clear Xt;
objmmls=obj;
sparmmls=spar;

%%% exp 1: batch algorithm 
%%% MM - no LS
param.minibatches=n;
param.strategy=0;
obj=[];
spar=[];
for ii=1:length(tabepochs)
   param.epochs=tabepochs(ii);   % one pass over the data
   fprintf('EXP WITH %d PASS OVER THE DATA\n',tabepochs(ii));
   tic
   [Beta tmp]=mexIncrementalProx(y,X,Beta0b,param);
   toc
   fprintf('Objective functions: \n');
   obj=[obj; tmp(1,:)];
   obj
   fprintf('Sparsity: \n');
   spar=[spar; sum(Beta ~= 0)];
   spar
end
objmm=obj;
sparmm=spar;

%% MISO0
param.minibatches=min(n,ceil(1/density));  % size of the minibatches, requires to store twice the size of X 
param.strategy=0;
obj=[];
spar=[];
for ii=1:length(tabepochs)
   param.epochs=tabepochs(ii);   % one pass over the data
   fprintf('EXP WITH %d PASS OVER THE DATA\n',tabepochs(ii));
   tic
   [Beta tmp]=mexIncrementalProx(y,X,Beta0b,param);
   fprintf('Objective functions: \n');
   obj=[obj; tmp(1,:)];
   obj
   fprintf('Sparsity: \n');
   spar=[spar; sum(Beta ~= 0)];
   spar
   toc
end
objmiso0=obj;
sparmiso0=spar;

%% MISO2
param.minibatches=min(n,ceil(1/density));  % size of the minibatches, requires to store twice the size of X 
param.strategy=3;
obj=[];
spar=[];
for ii=1:length(tabepochs)
   param.epochs=tabepochs(ii);   % one pass over the data
   fprintf('EXP WITH %d PASS OVER THE DATA\n',tabepochs(ii));
   tic
   [Beta tmp]=mexIncrementalProx(y,X,Beta0b,param);
   toc
   fprintf('Objective functions: \n');
   obj=[obj; tmp(1,:)];
   obj
   fprintf('Sparsity: \n');
   spar=[spar; sum(Beta ~= 0)];
   spar
end
objmiso2=obj;
sparmiso2=spar;

save(name,'objmmls','sparmmls','objmm','sparmm','objmiso0','sparmiso0','objmiso','sparmiso','objmiso2','sparmiso2');
